<?php

 /**
 * @package ODude DIR
 * @author ODude.com
 * @copyright (C) 2014 ODude Network. All rights reserved.
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.application.component.controller' );

class odudedirControllerCategories extends JControllerLegacy
{
	function __construct( $config = array() )
	{
		parent::__construct( $config );
		
		$this->registerTask( 'add',	  'edit' );
		$this->registerTask( 'app',		'save' );
		$this->registerTask( 'unpublish',	'publish' );
	}

	
	
	function display($cachable = false, $urlparams = array())
	{
		global $mainframe;
	$mainframe= JFactory::getApplication();
	$option 	= JRequest::getVar('option');
	
    $db = JFactory::getDBO();
	
	$filter_order= $mainframe->getUserStateFromRequest( $option.'filter_order','filter_order','id','cmd' );
	$filter_order_Dir= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir','','word' );
	$filter_order     = $mainframe->getUserStateFromRequest($option . '.filter_order', 'filter_order', 'ordering', 'cmd');
	$filter_state = $mainframe-> getUserStateFromRequest( $option.'filter_state', 	'filter_state', '','word' );
	$search_cat = $mainframe-> getUserStateFromRequest( $option.'search_cat', 'search_cat','','string' );
	$search_cat = JString::strtolower( $search_cat );
   
	$limit= $mainframe-> getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart= $mainframe-> getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
 $ord              = JRequest::getVar('ord', 1);
    if ($ord and ($filter_order == "title" or $filter_order == "cattitle" or $filter_order == "ordering" or $filter_order == "published" or $filter_order == "id"))
        $order = ' ORDER BY ' . $db->escape($filter_order). ' ' . $db->escape($filter_order_Dir ). ', ordering';
    else
        $order = "";
	$where = array();

	if ( $search_cat ) {
		$where[] = 'title  LIKE "%'.$db->escape($search_cat).'%"';
	
	}	
	
	$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
	if ($filter_order == 'id'){
		$orderby 	= ' ORDER BY id '. $filter_order_Dir .'';
	} else {
		$orderby 	= ' ORDER BY '. 
         $filter_order .' '. $filter_order_Dir .', id';
	}	
	
	// get the total number of records
	$query = 'SELECT COUNT(*)'
	. ' FROM #__odudedir_category'. $where;
	$db->setQuery( $query );
	$total = $db->loadResult();

	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );	
	
	
	$query = "SELECT id,published,ordering,template,subcat,alias,title as cattitle FROM #__odudedir_category". $where. $orderby;
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $db->loadObjectList();
	if($db->getErrorNum()){
		echo $db->stderr();
		return false;
	}
	
	// table ordering
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;	

	// search filter	
        $lists['search_cat']= $search_cat;

		require_once JPATH_COMPONENT.'/views/categories.php';
		odudedirViewCategories::categories( $rows, $pageNav, $lists );
		
	}
	
	
	
	

	function edit()
	{
		$db		= JFactory::getDBO();

	$cid 	= JRequest::getVar('cid', array(0), '', 'array');
	JArrayHelper::toInteger($cid, array(0));
	
	$id 	= $cid[0];

	$row = JTable::getInstance('dir_categories', 'Table');
	// load the row from the db table
	$row->load($id);
	
	
	
	$lists = array();
	$ordering['0'] = array(
        'value' => '0',
        'text' => '0 First'
    );
	$db = JFactory::getDBO();
    $query = "SELECT ordering,title FROM #__odudedir order by ordering";
    $db->setQuery($query);
    $rows1 = $db->loadObjectList();
    if ($db->getErrorNum())
      {
        echo $db->stderr();
        return false;
      }
   for ($i = 0, $n = count($rows1); $i < $n; $i++)
      {
        $row1 =& $rows1[$i];
        $ordering1            = $row1->ordering;
		 if (strlen($row1->title)<30){
		 $row_title=$row1->title;
		 }
		 else{
		 $row_title=substr_replace($row1->title,"...",30);
		 }
        $ordering[$ordering1] = array(
            'value' => $row1->ordering,
			'text' => ($row1->ordering . "(" . $row_title . ")")
		
        );
      }
    $ordering[(count($rows1) + 1)] = array(
        'value' => (count($rows1) + 1),
        'text' => (count($rows1) + 1) . ' Last'
    );
	
    if($row->ordering!="")
	{
	$selected=$row->ordering;
	}
	else {	
	if(!$rows1)
	$selected=$ordering[0];		
	else
	$selected=$ordering[(count($rows1) + 1)];
	}
	 $lists['ordering']             = JHTML::_('select.genericList', $ordering, 'ordering', 'class="inputbox" ' . '', 'value', 'text', $selected);
	 $lists['show_add'] = JHTML::_('select.booleanlist', 'show_add' , 'class="inputbox"', $row->show_add);
	 $lists['auto_publish'] = JHTML::_('select.booleanlist', 'auto_publish' , 'class="inputbox"', $row->auto_publish);
	$lists['published'] = JHTML::_('select.booleanlist', 'published' , 'class="inputbox"', $row->published);
	$lists['front'] = JHTML::_('select.booleanlist', 'front' , 'class="inputbox"', $row->front);

		require_once JPATH_COMPONENT.'/views/categories.php';
		odudedirViewCategories::category( $row, $lists );
	}

	
	function save()
	{
		global $mainframe;
		$mainframe= JFactory::getApplication();
	$row = JTable::getInstance('dir_categories', 'Table');
	if(!$row->bind(JRequest::get('post')))
	{
		JError::raiseError(500, $row->getError() );
	}
	$row->title = JRequest::getVar( 'title', '','post', 'string', JREQUEST_ALLOWRAW );
$row->description=JRequest::getVar('description', '', 'post' , 'STRING', JREQUEST_ALLOWRAW);
$row->html=JRequest::getVar('html', '', 'post' , 'STRING', JREQUEST_ALLOWRAW);
	
	if(!$row->store()){
		JError::raiseError(500, $row->getError() );
	}
	$mainframe->redirect('index.php?option=com_odudedir&c=categories', 'Successfully saved');
	}
	
	
	function apply()
	{
	
		global $mainframe;
		$mainframe= JFactory::getApplication();
	$row = JTable::getInstance('dir_categories', 'Table');
	if(!$row->bind(JRequest::get('post')))
	{
		JError::raiseError(500, $row->getError() );
	}
	$row->title = JRequest::getVar( 'title', '','post', 'string', JREQUEST_ALLOWRAW );
	$row->description=JRequest::getVar('description', '', 'post' , 'STRING', JREQUEST_ALLOWRAW);
	$row->html=JRequest::getVar('html', '', 'post' , 'STRING', JREQUEST_ALLOWRAW);
	
	if(!$row->store()){
		JError::raiseError(500, $row->getError() );
	}
	$mainframe->redirect('index.php?option=com_odudedir&c=categories&task=edit&cid[]='.$row->id,'Successfully saved changes');
	}
	

	/*function cancel()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$this->setRedirect( 'index.php?option=com_rand' );

		// Initialize variables
		$db		= JFactory::getDBO();
		$post	= JRequest::get( 'post' );
		$row	=& JTable::getInstance('questions', 'Table');
		$row->bind( $post );
		$row->checkin();
	}*/


	function publish()
	{
		

		$this->setRedirect( 'index.php?option=com_odudedir&c=categories' );
  // Initialize variables
  $db 	=& JFactory::getDBO();

  // define variable $cid from GET
  
  $cid = JRequest::getVar( 'cid' , array() , '' , 'array' );	
  JArrayHelper::toInteger($cid);

  $task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );

		if (empty( $cid )) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

		$query = 'UPDATE #__odudedir_category'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids.'  )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return JError::raiseWarning( 500, $db->getError() );
		}
		$this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );
	}

	function remove()
	{
		global $mainframe;
		$mainframe= JFactory::getApplication();
  // Initialize variables	
  $db = JFactory::getDBO();
  // Define cid array variable
  $cid = JRequest::getVar( 'cid' , array() , '' , 'array' );
  // Make sure cid array variable content integer format
  JArrayHelper::toInteger($cid);

  // If any item selected
  if (count( $cid )) {
    // Prepare sql statement, if cid array more than one, 
    // will be "cid1, cid2, ..."
    $cids = implode( ',', $cid );
	
	$query = "select * from #__odudedir where category='". $db->escape($cids )."'";
	$db->setQuery($query);
	$rows = $db -> loadObjectList();
	
	if(count($rows)==0)
	{
	
		$query = "select * from #__odudedir_category where subcat='". $db->escape($cids )."'";
		$db->setQuery($query);
		$rows = $db -> loadObjectList();
			if(count($rows)==0)
			{
	
				// Create sql statement
				$query = 'DELETE FROM #__odudedir_category'
				. ' WHERE id IN ( '. $cids .' )'
				;
				// Execute query
				$db->setQuery( $query );
				if (!$db->query()) 
				{
				  echo "<script> alert('".$db->getErrorMsg(true)."'); 
				  window.history.go(-1); </script>\n";
				}
			}
			else
			{
			echo "<script> alert('This cateogry has sub categories.'); 
						  window.history.go(-1); </script>\n";
			
			
			}
				
	}
	else
	{
	echo "<script> alert('This category have some post or titles. Delete or move those titles to other category.'); 
				  window.history.go(-1); </script>\n";
	
	
	}
  
  
  }

  
  
  
  
  
  // After all, redirect again to frontpage
  $mainframe->redirect( "index.php?option=com_odudedir&c=categories" );
	
}


function saveorder(&$cid)
  {
  global $mainframe;
     $mainframe = JFactory::getApplication();
    // Check for request forgeries
    JRequest::checkToken() or jexit('Invalid Token');
    // Initialize variables
    $db = JFactory::getDBO();
    $cid   = JRequest::getVar('cid', array(), '', 'array');
    $total = count($cid);
	
    $order = JRequest::getVar('order', array(0), 'post', 'array');
    JArrayHelper::toInteger($order, array(0));
    $row = JTable::getInstance('dir_categories', 'Table');
    $groupings = array();
    // update ordering values
    for ($i = 0; $i < $total; $i++)
      {
        $row->load((int) $cid[$i]);
        // track sections
        //echo $row->ordering;
        if ($row->ordering != $order[$i])
          {
            $row->ordering = $order[$i];
            if (!$row->store())
              {
                JError::raiseError(500, $db->getErrorMsg());
              }
          }
      }
    $msg = JText::_('New ordering saved');
    $mainframe->redirect('index.php?option=com_odudedir', $msg);
  }
}
