<?php


 /**
 * @package ODude DIR
 * @author ODude.com
 * @copyright (C) 2014 ODude Network. All rights reserved.
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 **/

defined( '_JEXEC' ) or die( 'Restricted access' );


if(!defined('DS')){
    define('DS',DIRECTORY_SEPARATOR);
}


JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_odudedir/tables');


$bar= JToolBar::getInstance( 'toolbar' );
$bar->appendButton('Custom','<a href="http://odude.com" target="_blank" style=""><img src="../components/com_odudedir/include/odude.png" border="0" alt="http://odude.com" style="float:left"></a>', 'custom');

$controllerName = JRequest::getCmd( 'c', 'questions' );


if($controllerName == 'categories') 
{
	JSubMenuHelper::addEntry(JText::_('Title List'), 'index.php?option=com_odudedir');
	JSubMenuHelper::addEntry(JText::_('Categories'), 'index.php?option=com_odudedir&c=categories', true );
	JSubMenuHelper::addEntry(JText::_('Help'), 'index.php?option=com_odudedir&c=help');
	//JSubMenuHelper::addEntry(JText::_('Fields'), 'index.php?option=com_odudedir&c=fields');
} 
else if($controllerName == 'help') 
{
	JSubMenuHelper::addEntry(JText::_('Title List'), 'index.php?option=com_odudedir');
	JSubMenuHelper::addEntry(JText::_('Categories'), 'index.php?option=com_odudedir&c=categories' );
	JSubMenuHelper::addEntry(JText::_('Help'), 'index.php?option=com_odudedir&c=help', true);
	//JSubMenuHelper::addEntry(JText::_('Fields'), 'index.php?option=com_odudedir&c=fields');
} 

else
 {
			if($controllerName == 'help')
			{
				JSubMenuHelper::addEntry(JText::_('Title List'), 'index.php?option=com_odudedir');
				JSubMenuHelper::addEntry(JText::_('Categories'), 'index.php?option=com_odudedir&c=categories');
				//JSubMenuHelper::addEntry(JText::_('Help'), 'index.php?option=com_odudedir&c=help', true);
				//	JSubMenuHelper::addEntry(JText::_('Fields'), 'index.php?option=com_odudedir&c=fields');
			}
			else
			{
					if($controllerName == 'fields')
					{
					JSubMenuHelper::addEntry(JText::_('Title List'), 'index.php?option=com_odudedir');
					JSubMenuHelper::addEntry(JText::_('Categories'), 'index.php?option=com_odudedir&c=categories');
					//JSubMenuHelper::addEntry(JText::_('Themes'), 'index.php?option=com_odudedir&c=themes');
					//	JSubMenuHelper::addEntry(JText::_('Fields'), 'index.php?option=com_odudedir&c=fields', true);
					}
					else
					{
						JSubMenuHelper::addEntry(JText::_('Title List'), 'index.php?option=com_odudedir', true);
					JSubMenuHelper::addEntry(JText::_('Categories'), 'index.php?option=com_odudedir&c=categories');
					JSubMenuHelper::addEntry(JText::_('Help'), 'index.php?option=com_odudedir&c=help');
					//	JSubMenuHelper::addEntry(JText::_('Fields'), 'index.php?option=com_odudedir&c=fields');
						
					}
			}
}

switch ($controllerName)
{
	default:
		$controllerName = 'questions';
		// allow fall through

	case 'questions' :
	
	case 'categories':
		// Temporary interceptor
		$task = JRequest::getCmd('task');
		
		if ($task == 'categories') {
			$controllerName = 'categories';
		}
		
		case 'help':
		// Temporary interceptor
		$task = JRequest::getCmd('task');
		
		if ($task == 'help') {
			$controllerName = 'help';
		}
		
		case 'plggen':
		// Temporary interceptor
		$task = JRequest::getCmd('task');
		
		if ($task == 'fields') {
			$controllerName = 'fields';
		}
		
case 'addcat':
		// Temporary interceptor
		$task = JRequest::getCmd('task');
		
		if ($task == 'addcat') {
			$controllerName = 'addcat';
		}
	
case 'addcontent':
		// Temporary interceptor
		$task = JRequest::getCmd('task');
		
		if ($task == 'addcontent') {
			$controllerName = 'addcontent';
		}	
		
		
case 'images':
		// Temporary interceptor
		$task = JRequest::getCmd('task');
		
		if ($task == 'images') {
			$controllerName = 'images';
		}
		
		
		
		
		require_once( JPATH_COMPONENT.'/controllers/'.$controllerName.'.php' );
		$controllerName = 'odudedirController'.$controllerName;

		// Create the controller
		$controller = new $controllerName();

		// Perform the Request task
		$controller->execute( JRequest::getCmd('task') );

		// Redirect if set by the controller
		$controller->redirect();
		break;
}


			
			